
;***********************************************
; t1 = bin_L
; t2 = bin_H

bin2bcd2REG:

clr LED7segment_1
clr LED7segment_2

segment_1:	; 3   
	SUBI t1, 100
	BRCS bin_H_is_zerro;   
	INC LED7segment_1
	RJMP segment_1

bin_H_is_zerro: ;     
	CPI t2, 0
	BREQ end_segment_1 ;    
	DEC t2
	INC LED7segment_1
	RJMP segment_1


end_segment_1:
	SUBI t1, -100 ; 2   

segment_2:
	SUBI t1, 10
	BRCS end_bin2bcd2REG
	INC LED7segment_2
	RJMP segment_2

end_bin2bcd2REG:

	RET



;***** Decimap digit converts to 7-segment indicator *****

DecTo7LedPort:
	CPI t1, 0
	BREQ digit0

	CPI t1, 1
	BREQ digit1

	CPI t1, 2
	BREQ digit2

	CPI t1, 3
	BREQ digit3

	CPI t1, 4
	BREQ digit4

	CPI t1, 5
	BREQ digit5

	CPI t1, 6
	BREQ digit6

	CPI t1, 7
	BREQ digit7

	CPI t1, 8
	BREQ digit8

	CPI t1, 9
	BREQ digit9

digit0: 
	LDI t1, 0b11111100
	RJMP to7LedPort

digit1: 
	LDI t1, 0b01100000
	RJMP to7LedPort

digit2: 
	LDI t1, 0b11011010
	RJMP to7LedPort

digit3: 
	LDI t1, 0b11110010
	RJMP to7LedPort

digit4: 
	LDI t1, 0b01100110
	RJMP to7LedPort

digit5: 
	LDI t1, 0b10110110
	RJMP to7LedPort

digit6: 
	LDI t1, 0b10111110
	RJMP to7LedPort

digit7: 
	LDI t1, 0b11100000
	RJMP to7LedPort

digit8: 
	LDI t1, 0b11111110
	RJMP to7LedPort

digit9: 
	LDI t1, 0b11110110
	RJMP to7LedPort
	
to7LedPort:
	
	SBRS t1, 7 ;a
	RJMP a
	CBI PORTA, 1
	RJMP aend
a: 	SBI PORTA, 1
aend:

	SBRS t1, 6 ;b
	RJMP b
	CBI PORTA, 0
	RJMP bend
b:	SBI PORTA, 0
bend:

	SBRS t1, 5 ;c
	RJMP c
	CBI PORTD, 2
	RJMP cend
c:	SBI PORTD, 2
cend:

	SBRS t1, 4 ;d
	RJMP d
	CBI PORTD, 3
	RJMP dend
d:	SBI PORTD, 3
dend:

	SBRS t1, 3 ;e
	RJMP e
	CBI PORTD, 4
	RJMP eend
e:	SBI PORTD, 4
eend:

	SBRS t1, 2 ;f
	RJMP f
	CBI PORTD, 5
	RJMP fend
f:	SBI PORTD, 5
fend:

	SBRS t1, 1 ;g
	RJMP g
	CBI PORTD, 6
	RJMP gend
g:	SBI PORTD, 6
gend:

RET
