uart_init:
		LDI 	R16, low(bauddivider)
		OUT 	UBRRL,R16
		LDI 	R16, high(bauddivider)
		OUT 	UBRRH,R16
 
		LDI 	R16,0
		OUT 	UCSRA, R16
 
;  , - .
		LDI 	R16, (0<<RXEN)|(1<<TXEN)|(0<<RXCIE)|(0<<TXCIE)|(0<<UDRIE)
		OUT 	UCSRB, R16	
 
;   - 8 ,    UCSRC,     
		LDI 	R16, (1<<UCSZ0)|(1<<UCSZ1)
		OUT 	UCSRC, R16
		RET


;===================
;= 0: (A) =
;===================

pwm_init:
	;     (WGM0). 
	;    (COM0n).
	LDI t1, 1<<COM0A1|1<<WGM01|1<<WGM00 ;   . 
	OUT TCCR0A, t1 ;    

	;     
	LDI t1,  1<<CS00|0<<WGM02 ;   . 
	OUT TCCR0B, t1 ;    

	LDI t1, 1<<TOIE0 ;   . 
	OUT TIMSK, t1 ;    

	;CLI ; 
	OUT OCR0A,lev_pwm
	;SEI ; 
	RET


;===============================
;= 1:   =
;===============================
disp_init:
	LDI t1, 1<<OCIE1A ;Interrup En
	OUT TIMSK, t1
	
	LDI t1, 1<<WGM12|1<<CS10 ; CTC
	OUT TCCR1B, t1

	LDI t1, 8
	OUT OCR1AH, t1

	RET


;=========================
;=   =
;=========================
analog_comp_init:


	SBI ACSR, ACIE
	SBI ACSR, ACIS0
	SBI ACSR, ACIS1

	RET



ports_init:

	CBI DDRB, 0 ;analog_comp
	CBI PORTB, 0

	CBI DDRB, 1
	CBI PORTB, 1
	
	SBI DDRB, 2 ;PWM
	SBI PORTB, 2

	SBI DDRB, 3  ;LEDS 1 2 digit 
	SBI PORTB, 3 ;+

	SBI DDRB, 4
	CBI PORTB, 4 ;-
	
				;LEDS 7 seg (PullUp R=100)
	SBI DDRA, 0  ; b
	SBI PORTA, 0 

	SBI DDRA, 1  ; a
	SBI PORTA, 1 

	SBI DDRD, 2  ; c
	SBI PORTD, 2 

	SBI DDRD, 3  ; d
	SBI PORTD, 3

	SBI DDRD, 4  ; e
	SBI PORTD, 4

	SBI DDRD, 5  ; f
	SBI PORTD, 5

	SBI DDRD, 6  ; g
	SBI PORTD, 6
	
	RET
